/*
Project: ffm-main-template.
Description: A simple menu .main-menu[--center, --right]. Requires it's own row.
TODO: Refactor this.
Author: Tatsumi Suzuki
Date: 2016-07-12
Licence: https://fastforwardmedia.se

Table of contents

1.	Menu variables and settings
2.	Menu
3.	Menu fixed style / requires js toggle .fixed class.
4.	Mobile menu
*/

/*
1.	Menu variables and settings
*/

// Desktop
$menu-margins: $glutter;
$menu-color: $font-color-1;
$menu-highlighted-color: $background-color-1;

// Mobile
$trigger-mobile-on: $mobile-breakpoint;
$hamburger-bg-color: $font-color-1;
$hamburger-line-color: $background-color-1;
$mobile-menu-bg: $font-color-1;
$mobile-menu-text-color: $background-color-1;

/*
2.	Menu
*/
[class*="main-menu"] {

	overflow: hidden;
	padding-bottom: $glutter;

	&[class*="--center"] {
		text-align: center;
	}

	&[class*="--right"] {
		text-align: right;
	}

	li {
		display: inline-block;
		margin: 0 $menu-margins 0 0;
		padding: 0;

		&:last-of-type {
			margin: 0;
		}

		&.current-menu-item a {
			color: $menu-highlighted-color;
		}

		&.current-menu-item a::after {
			width: 80%;
			left: 50%;
			transform: translateX(-50%);
			border-bottom: 1px solid $menu-highlighted-color;
		}
	}
	a {
		color: $menu-color;
		padding: 0 0 $menu-margins/2 0;
		text-decoration: none;
		position: relative;
		overflow: hidden;

		&:after {
			width: 0;
			content: '';
			position: absolute;
			left: 50%;
			bottom: 0;
			border-bottom: 1px solid transparent;
			transition: all 0.2s ease-in-out;
		}

		&:hover::after {
			width: 80%;
			left: 50%;
			transform: translateX(-50%);
			border-bottom: 1px solid $menu-highlighted-color;
		}
	}
}

/*
3.	Menu fixed style / requires js toggle .fixed class.
*/

header.header {
	width: 100%;
	position: absolute;
	transition: all 0.7s ease;

	&.fixed {
		position: fixed;
	}

	&.scrolled {
		transform: translateY(-100%);
	}
}

/*
4.	Mobile Menu
*/

[class*="main-menu"] {
	label,
	input {
		display: none;
	}
}

@media all and (max-width: $trigger-mobile-on) {

	[class*="main-menu"] {

		// Un-checked state
		label {
			display: block;
			margin: 0 auto;
		}

		label {
			width: 55px;
			height: 55px;
			cursor: pointer;
			position: relative;
			transition: background 0s 0.3s;
			background-color: $hamburger-bg-color;
		}

		label span {
			width: 35px;
			height: 2px;
			background-color: $hamburger-line-color;
			position: absolute;
			top: 50%;
			left: 10px;
			transform: translateY(-50%);

			&:before,
			&:after {
				content:'';
				width: 35px;
				height: 2px;
				transition-duration: 0.3s, 0.3s;
				transition-delay: 0.3s, 0s;
				background-color: $hamburger-line-color;
				position: absolute;
				left: 0;
			}

			&:before {
				transition-property: top, transform;
				top: -10px;
			}

			&:after {
				transition-property: bottom, transform;
				bottom: -10px;
			}
		}

		ul {
			height: 0;
			overflow: hidden;
			visibility: hidden;
			transition: all 0.5s ease;

			li {
				max-height: 0;
				transition: max-height 0.5s ease;
			}
		}

		// Checked state
		input[type=checkbox]:checked ~ label[for="main-menu-button"] {

			span {
				background-color: transparent;
			}

			span::before {
				top: 0;
				transition-delay: 0s,.3s;
				transform: rotate(45deg);
			}

			span::after {
				bottom: 0;
				transition-delay: 0s,.3s;
				transform: rotate(-45deg);
			}
		}

		input[type=checkbox]:checked ~ ul {
			height: auto;
			padding: $menu-margins;
			text-align: center;
			visibility: visible;
			background-color: $mobile-menu-bg;

			li {
				display: block;
				margin: 0;
				max-height: 100px;
				overflow: hidden;
			}

			a {
				display: block;
				padding: $menu-margins/2 $menu-margins;
				color: $mobile-menu-text-color;
			}

			a::after {
				border-color: $mobile-menu-text-color;
			}
		}
	}
}
